﻿<template>
    <form class="form"
          novalidate
          @submit.prevent="handleSubmit"
          enctype="multipart/form-data">
        <FormRow>
            <FormInput v-model="waitingMember.firstName"
                       type="text"
                       name="firstName"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.firstName')"
                       @validated="handleValidation" />
            <FormInput v-model="waitingMember.lastName"
                       type="text"
                       name="lastName"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.lastName')"
                       @validated="handleValidation" />
        </FormRow>
        <FormInput v-model="waitingMember.adress"
                   type="text"
                   name="adress"
                   :ref="addFormInputRef"
                   :label="t('waitingMember.adress')"
                   @validated="handleValidation"/>
        <FormRow>
            <FormInput v-model="waitingMember.appNb"
                       type="number"
                       name="appNb"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.appNb')"
                       :rules="[]"
                       @validated="handleValidation" />
            <FormInput v-model="waitingMember.postalCode"
                       type="text"
                       name="postalCode"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.postalCode')"
                       @validated="handleValidation" />
        </FormRow>
        <FormRow>
            <FormInput v-model="waitingMember.email"
                       type="email"
                       name="email"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.email')"
                       @validated="handleValidation" />
            <FormInput v-model="waitingMember.phoneNumber"
                       type="text"
                       name="phoneNumber"
                       placeholder="4181234567"
                       :ref="addFormInputRef"
                       :label="t('waitingMember.phoneNumber')"
                       @validated="handleValidation" />
        </FormRow>
        <FormRow>
            <FormRadios
                        v-model="waitingMember.from"
                        title="Je suis avec"
                        name="from"
                        :options="radioOptions"
                        required="True"
                        />
        </FormRow>
        <button class="form__submit btn btn--fullscreen" type="submit">
            {{ t("global.add") }}
        </button>
    </form>
</template>

<script lang="ts" setup>
import FormRow from "@/components/forms/FormRow.vue"
import FormInput from "@/components/forms/FormInput.vue"
import FormRadios from "@/components/forms/FormRadios.vue"
import ProductBaseForm from "@/components/products/ProductBaseForm.vue"
import {ref} from "vue"
import {useI18n} from "vue3-i18n"
import {notifyError} from "@/notify"
import {Status} from "@/validation"
import { FormOption } from "@/types/formOption"
import { WaitingMember } from "@/types/entities/waitingMember"

// eslint-disable-next-line no-undef
const props = defineProps<{
    waitingMember?: WaitingMember
}>()

// eslint-disable-next-line
const emit = defineEmits<{
    (event: "formSubmit", waitingMember: WaitingMember): void
}>()

const { t } = useI18n()

const waitingMember = ref<WaitingMember>(props.waitingMember ?? {})
//So that a radio is selected from the start
waitingMember.value.from = "cegep"
const radioOptions: FormOption[] = [{ name: "cegep", label: "Le Cégep Garneau" }, { name: "loisirs", label: "Les loisirs Saint-Sacrement" }]
const formInputs = ref<any[]>([])
const inputValidationStatuses:any = {}

function addFormInputRef(ref: typeof FormInput) {
    if (!formInputs.value.includes(ref) && ref)
        formInputs.value.push(ref)
}

async function handleValidation(name: string, validationStatus: Status) {
    inputValidationStatuses[name] = validationStatus.valid
}

async function handleSubmit() {
    formInputs.value.forEach((x: typeof FormInput) => x.validateInput())
    if (Object.values(inputValidationStatuses).some(x => x === false)) {
        notifyError(t('global.formErrorNotification'))
        return
    }
    emit("formSubmit", waitingMember.value)
}
</script>